/*
Original written by:
            Cytron Technologies

Modified:
  29/06/15  Idris, Cytron Technologies    - Point to IDE SoftwareSerial
                                          - Restructure the code style to follow standard Arduino library
  19/01/17  Dream Drive!!                 - ROBOTIS社のOpenCM9.0.4で使用出来るように書き換えました
                                          - ハードウェアシリアル3で動作します

*/

#include "HardwareSerial.h"
#include "Cytron_PS2Shield.h"

void Cytron_PS2Shield::begin(uint32_t baudrate)
{
	hardwareSerial = true;
	Serial3.begin(baudrate);
//	while(!Serial3);			//シリアルが初期化されるまで待つ()

//	pinMode(A1, OUTPUT);		// HWリセットピンの初期化(実装しません)
//	digitalWrite(A1, HIGH);		// HWリセットピンの初期化(実装しません)
}

void Cytron_PS2Shield::write(uint8_t data)
{
	while(Serial3.available() > 0) {
		Serial3.read();
	}
	Serial3.write(data);
	Serial3.flush();		// Wait for all data transmitted
}

uint8_t Cytron_PS2Shield::read(void)
{
	uint8_t rec_data; 
	long waitcount = 0; 
	
	while(true)
	{
		if(Serial3.available() > 0)
		{
			rec_data = Serial3.read();
			SERIAL_ERR = false;
			return(rec_data);
		}
		waitcount++;
		if(waitcount > 50000)		//元の倍に(適当)
		{
			SERIAL_ERR = true; 
			return(0xFF); 
		}
	}
}

uint8_t Cytron_PS2Shield::readButton(uint8_t key)
{
	write(key);
	return read();
}

boolean Cytron_PS2Shield::readAllButton(void)
{
	uint8_t nbyte; 
	uint32_t waitcount;
	
	write(PS2_BUTTON_JOYSTICK);
		waitcount = 0; 
		while(Serial3.available() < 6)
		{
			waitcount++; 
			if(waitcount > 500000) {	
				return (false);
			}
		}		
		for(int i = 0; i < 6; i++) {
			ps_data[i] = Serial3.read();
		}
	return(true);
}

void Cytron_PS2Shield::vibrate(uint8_t motor, uint8_t value)
{
	uint8_t _motor;

	if(motor == 1) _motor = PS2_MOTOR_1; 
	else _motor = PS2_MOTOR_2;
	
	write(_motor);
	write(value); 
}

void Cytron_PS2Shield::reset(uint8_t reset)
{
//	if(reset == 1) digitalWrite(A1, LOW);				// 
//	else digitalWrite(A1, HIGH);						// HWリセット
// 
// 実装していません。
}